it.emasab.Mailclassifier.File = function(){
	
	this.MODE_RDWR= 0x20 | 0x04;
	this.MODE_RDONLY= 0x01;
	this.messenger = it.emasab.Mailclassifier.Services.messenger;

	this.initialize = function(dir, fileName){
		var file = it.emasab.Mailclassifier.Services.ds.get('ProfD', Components.interfaces.nsIFile).clone();
		file.append("MailClassifier");
		if(dir && dir.length>0) file.append(dir);
		file.append(fileName);
		this.file=file;
		this.invalid=false;
		if(!file.exists()){
			try{		
				file.create(0,0666);
			}
			catch(e){this.invalid=true;}
		}
		this.out = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
		this.inp = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);	
	}

	this.getScriptableStream = function(is){
		var sis=Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
		sis.init(is);
		return sis;	this.initialize_base
	}

	this.save = function(){
		if(!this.invalid){
			this.out.init(this.file,this.MODE_RDWR, 0666, 0 );		
			this.write(this.out);
			this.out.close();
		}
	}	
	this.load = function(){
		if(!this.invalid){
			this.inp.init(this.file,this.MODE_RDONLY,0666,1);
			var inp = this.getScriptableStream(this.inp);
			this.read(inp);
			inp.close();
			this.inp.close();
		}
	}
}

it.emasab.Mailclassifier.AccountFile = function(){
	this.initialize_base = this.initialize;
	this.initialize = function(account, filename){
		this.account = account;
		this.initialize_base(account.mozAccount.realUsername + 
			"@" +account.mozAccount.realHostName, filename);
	}
}

it.emasab.Mailclassifier.AccountFile.prototype = new it.emasab.Mailclassifier.File();
